#ifndef CYOA_H
#define CYOA_H

#include <vector>
#include <set>

#define STATCHECK_GT 1
#define STATCHECK_LT 2

struct statcheck_t {
  char *stat;
  int value;
  int rel;
};

struct statchange_t {
  char *stat;
  int addend;
};

struct Choice {
  int option;
  char *flavor;
  statcheck_t *statcheck;
  char *id;
  statchange_t *statchange;

  Choice(char*, statcheck_t *statcheck, statchange_t *statchange);
};

struct ChoiceComparator {
  bool operator()(const Choice* a, const Choice* b) const {
    return a->option < b->option;
  }
};

typedef std::set<Choice*, ChoiceComparator> ChoiceList;


enum class FooterType {
  End,
  Goto,
  Choices
};

struct Footer {
  FooterType type;
  union {
    ChoiceList *choices;
    char *link;
  };

  Footer();
  ~Footer();
};

struct Page {
  char *id;
  char *body;
  Footer footer;

  Page();
  ~Page();
};

std::vector<Page*> CyoaParse(FILE *);

#endif /* CYOA_H */

// Local Variables:
// mode: c++
// End:
